file: text

text: text text_element
    | text_element

text_element: data_decl
            | class_decl
            | plain_proc
            | block
            | include_item
            | pragma_item

pragma_item:  PRAGMA QUOTEDSTR

include_item: INCLUDE QUOTEDSTR

data_decl: ID "=" ID ";"
         | ID "=" ID "(" LONG ")" ";"
         | ID "=" ID "(" LONG "," LONG ")" ";"

class_decl: ID "=" CLASS "(" id_list ")" duplicate_option class_body lookup_def hide_def _END ";"

duplicate_option:
                | _WITH DUPLICATE
lookup_def:
          | LOOKUP ID ";"

hide_def  :
          | HIDE _FOR hide_type_list "(" id_list ")"  ";"

hide_type_list : hide_type_list "," hide_type_item
               | hide_type_item

hide_type_item : VIEW
               | _INSERT
               | UPDATE

class_body: _class_body
          |

_class_body: _class_body class_body_item
          | class_body_item

class_body_item: class_field
               | class_proc
               | class_constraint
               | class_trigger
               | class_modificator
               | class_duplicater
               | class_index

class_index:   INDEX ID ON id_list ";"

class_duplicater: DUPLICATE ID BY ID ";"

class_field: ID ":" ID                       field_constraint_list ";"
           | ID ":" ID "(" LONG ")"          field_constraint_list ";"
           | ID ":" ID "(" LONG "," LONG ")" field_constraint_list ";"
           | ID AS _duplicated ID            field_constraint_list ";"

_duplicated :
           | DUPLICATED

field_constraint_list: field_constraint_list field_constraint
                     | field_constraint

field_constraint: NULL
                | _NOT NULL
                | UNIQUE
                | DEFAULT braced_text
                | CHECK   braced_text

braced_text: "{" <any text> "}"

class_constraint: UNIQUE  "(" id_list ")" ";"
                  | CHECK   braced_text   ";"


id_list: id_list "," ID
       | ID

class_proc: PROC ID proc_params proc_type braced_text ";"

class_modificator: MODIFICATOR _FOR id_list braced_text ";"

plain_proc: PROC ID proc_params braced_text ";"

proc_type:
         | _VIRTUAL
         | CLASS

proc_params:
            | "(" param_list ")"

param_list: param_list ";" param_decl
          | param_decl

param_decl: param_type ID ":" ID
         | param_type ID ":" ID "(" LONG ")"
         | param_type ID ":" ID "(" LONG "," LONG ")"

param_type:
          | _VAR

class_trigger: TRIGGER ID ON trigger_type_set braced_text ";"

trigger_type_set: trigger_type_set "," trigger_type
                | trigger_type

trigger_type:   _INSERT
            |   UPDATE
            |   _DELETE

block   : braced_text ";"

