
  function is_keyword(S:string):integer;
    begin
      is_keyword:=-1;
      if UpcaseStr(S)='CLASS'     then is_keyword:=CLASS;
      if UpcaseStr(S)='AS'        then is_keyword:=AS;
      if UpcaseStr(S)='NULL'      then is_keyword:=NULL;
      if UpcaseStr(S)='NOT'       then is_keyword:=_NOT;
      if UpcaseStr(S)='END'       then is_keyword:=_END;
      if UpcaseStr(S)='PROCEDURE' then is_keyword:=PROC;
      if UpcaseStr(S)='UNIQUE'    then is_keyword:=UNIQUE;
      if UpcaseStr(S)='CHECK'     then is_keyword:=CHECK;
      if UpcaseStr(S)='DEFAULT'   then is_keyword:=DEFAULT;
      if UpcaseStr(S)='LOOKUP'    then is_keyword:=LOOKUP;
      if UpcaseStr(S)='HIDE'      then is_keyword:=HIDE;
      if UpcaseStr(S)='VIRTUAL'   then is_keyword:=_VIRTUAL;
      if UpcaseStr(S)='VAR'       then is_keyword:=_VAR;
      if UpcaseStr(S)='TRIGGER'   then is_keyword:=TRIGGER;
      if UpcaseStr(S)='ON'        then is_keyword:=ON;
      if UpcaseStr(S)='FOR'       then is_keyword:=_FOR;
      if UpcaseStr(S)='VIEW'      then is_keyword:=VIEW;
      if UpcaseStr(S)='INSERT'    then is_keyword:=_INSERT;
      if UpcaseStr(S)='UPDATE'    then is_keyword:=UPDATE;
      if UpcaseStr(S)='DELETE'    then is_keyword:=_DELETE;
      if UpcaseStr(S)='DUPLICATED' then is_keyword:=DUPLICATED;
      if UpcaseStr(S)='DUPLICATE'  then is_keyword:=DUPLICATE;
      if UpcaseStr(S)='WITH'       then is_keyword:=_WITH;
      if UpcaseStr(S)='BY'         then is_keyword:=BY;
      if UpcaseStr(S)='#INCLUDE'   then is_keyword:=INCLUDE;
      if UpcaseStr(S)='MODIFICATOR' then is_keyword:=MODIFICATOR;
    end;

L                               [A-Za-z_@#]
D				[0-9]

%%

  var Idx      : integer;
      S        : string;
      I        : integer;
      C        : char;

"//".*[\n\f]                    ;

"(*"                            begin
                                  s:='';
                                  repeat
                                    c:=get_char;
                                    s:=s+c; if length(s)>2 then delete(s,1,1);
                                  until (c=#0) or (s='*)');
                                end;

"'"[^\'\n\f]*[\'\n\f]          begin
                                 if Copy(yytext,Length(yytext),1)=''''
                                   then begin
                                     yylval.yyPString:=NewStr(Copy(yytext,2,Length(yytext)-2));
                                     return(QUOTEDSTR);
                                   end else return(ILLEGAL);
                               end;

{L}({L}|{D})*                   begin
                                  i:=is_keyword(yytext);
                                  if i<0
                                    then begin
                                      yylval.yyPString:=NewStr(LocaseStr(yytext));
                                      return(ID);
                                    end else return(i);
				end;

{D}+                            begin
                                  if Str2Long(yytext,yylval.yyLongint)
                                    then return(LONG)
                                    else return(ILLEGAL);
				end;

[ \f\t\n]                       ;

.                               returnc(yytext[1]);

%%

